<?php
/**
 * @var \MODX\Revolution\modX $modx
 * @var array $namespace
 */

// Include autoloader generated by your composer
require_once $namespace['path'] . 'vendor/autoload.php';

if (!$modx->services->has('cspect')) {
    // Register base class in the service container
    $modx->services->add('cspect', function($c) use ($modx) {
        return new \CSPect\CSPect($modx);
    });

    // Load packages model, uncomment if you have DB tables
    $modx->addPackage('CSPect\Model', $namespace['path'] . 'src/', null, 'CSPect\\');
}

// More about this file: https://docs.modx.com/3.x/en/extending-modx/namespaces#bootstrapping-services
